/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.16 Revision 1.54
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.16 2009/03/15 15:27:13 alexxy Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.54 2011/06/07 20:11:04 abcd Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
10# This eclass provides all necessary functions for writing split KDE ebuilds. 10# This eclass provides all necessary functions for writing split KDE ebuilds.
11# 11#
12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional. 12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional.
13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY. 13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY.
14 14
15[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
16
15inherit kde4-base versionator 17inherit kde4-base versionator
16 18
17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm 19KDEMETA_EXPF="pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm"
18 20EXPORT_FUNCTIONS ${KDEMETA_EXPF}
19if [[ -z ${KMNAME} ]]; then
20 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
21fi
22
23case ${KDEBASE} in
24 kde-base)
25 HOMEPAGE="http://www.kde.org/"
26 LICENSE="GPL-2"
27 ;;
28 koffice)
29 HOMEPAGE="http://www.koffice.org/"
30 LICENSE="GPL-2"
31 ;;
32esac
33 21
34# Add dependencies that all packages in a certain module share. 22# Add dependencies that all packages in a certain module share.
35case ${KMNAME} in 23case ${KMNAME} in
36 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphic) 24 kdebase|kdebase-apps|kde-baseapps|kdebase-workspace|kde-workspace|kdebase-runtime|kde-runtime|kdegraphics)
37 DEPEND="${DEPEND} 25 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
38 >=kde-base/qimageblitz-0.0.4
39 "
40 RDEPEND="${RDEPEND}
41 >=kde-base/qimageblitz-0.0.4
42 "
43 ;; 26 ;;
44 kdenetwork) 27 kdepim|kdepim-runtime)
45 DEPEND="${DEPEND}
46 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
47 "
48 RDEPEND="${RDEPEND}
49 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
50 "
51 ;;
52 kdepim)
53 DEPEND="${DEPEND}
54 dev-libs/boost
55 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
56 "
57 RDEPEND="${RDEPEND}
58 dev-libs/boost
59 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
60 "
61 case ${PN} in 28 case ${PN} in
62 akregator|kaddressbook|kjots|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker) 29 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
63 IUSE="+kontact" 30 IUSE+=" +kontact"
64 RDEPEND="${RDEPEND} 31 RDEPEND+=" kontact? ( $(add_kdebase_dep kontact) )"
65 kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] )
66 "
67 ;; 32 ;;
68 esac 33 esac
69 ;; 34 ;;
70 kdegames) 35 kdegames)
71 if [[ ${PN} != libkdegames ]]; then 36 if [[ ${PN} != libkdegames ]]; then
72 DEPEND="${DEPEND} 37 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
73 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
74 "
75 RDEPEND="${RDEPEND}
76 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
77 "
78 fi 38 fi
79 ;; 39 ;;
80 koffice) 40 koffice)
81 [[ ${PN} != koffice-data ]] && IUSE="debug" 41 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
82 case ${PV} in 42 RDEPEND+="
83 9999*)
84 DEPEND="${DEPEND}
85 !app-office/${PN}:2
86 "
87 ;;
88 1.9*|2*)
89 DEPEND="${DEPEND}
90 !app-office/${PN}:live
91 "
92 ;;
93 esac
94 DEPEND="${DEPEND}
95 !app-office/${PN}:0 43 !app-office/${PN}:0
96 !app-office/koffice:0 44 !app-office/koffice:0
97 !app-office/koffice-meta:0 45 !app-office/koffice-meta:0
98 " 46 "
99 case ${PN} in 47 if has openexr ${IUSE//+}; then
100 koffice-data) 48 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
101 DEPEND="${DEPEND} 49 else
102 media-libs/lcms 50 COMMONDEPEND+=" media-gfx/imagemagick"
103 " 51 fi
104 RDEPEND="${RDEPEND} 52
105 media-libs/lcms
106 "
107 ;;
108 *)
109 COMMON_DEPEND=" 53 COMMONDEPEND+="
110 dev-cpp/eigen:2 54 dev-cpp/eigen:2
111 media-gfx/imagemagick[openexr?]
112 media-libs/fontconfig 55 media-libs/fontconfig
113 media-libs/freetype:2 56 media-libs/freetype:2
114 " 57 "
115 DEPEND="${DEPEND} ${COMMON_DEPEND}"
116 RDEPEND="${RDEPEND} ${COMMON_DEPEND}"
117 unset COMMON_DEPEND
118 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then 58 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
119 DEPEND="${DEPEND} 59 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
120 >=app-office/koffice-libs-${PV}:${SLOT}[kdeprefix=]
121 "
122 RDEPEND="${RDEPEND}
123 >=app-office/koffice-libs-${PV}:${SLOT}[kdeprefix=]
124 "
125 fi 60 fi
126 ;;
127 esac
128 ;; 61 ;;
129esac 62esac
63
64DEPEND+=" ${COMMONDEPEND}"
65RDEPEND+=" ${COMMONDEPEND}"
66unset COMMONDEPEND
130 67
131debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 68debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
132debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 69debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
133 70
134# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc) 71# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
135case ${BUILD_TYPE} in 72case ${BUILD_TYPE} in
136 live) 73 live)
74 if [[ ${KDE_SCM} == svn ]]; then
137 case ${KMNAME} in 75 case ${KMNAME} in
138 extragear*|playground*) 76 extragear*|playground*)
139 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}" 77 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
78 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
140 ;; 79 ;;
141 esac 80 esac
81 fi
142 ;; 82 ;;
143 *) ;;
144esac 83esac
145 84
146# @ECLASS-VARIABLE: KMNAME 85# @ECLASS-VARIABLE: KMNAME
147# @DESCRIPTION: 86# @DESCRIPTION:
148# Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it 87# Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it
162# If set to "true", $KMMODULE doesn't have to be defined. 101# If set to "true", $KMMODULE doesn't have to be defined.
163# 102#
164# Example usage: If you're installing subdirectories of a package, like plugins, 103# Example usage: If you're installing subdirectories of a package, like plugins,
165# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and 104# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
166# set KMNOMODULE="true". 105# set KMNOMODULE="true".
167if [[ -z ${KMMODULE} && ${KMNOMODULE} != true ]]; then 106if [[ -z ${KMMODULE} ]] && [[ ${KMNOMODULE} != true ]]; then
168 KMMODULE=${PN} 107 KMMODULE=${PN}
169fi 108fi
170 109
171# @ECLASS-VARIABLE: KMEXTRA 110# @ECLASS-VARIABLE: KMEXTRA
172# @DESCRIPTION: 111# @DESCRIPTION:
173# All subdirectories listed here will be extracted, compiled & installed. 112# All subdirectories listed here will be extracted, compiled & installed.
174# $KMMODULE is always added to $KMEXTRA. 113# $KMMODULE is always added to $KMEXTRA.
175# If the htmlhandbook USE-flag is set, and if this directory exists, 114# If KDE_HANDBOOK is 'always' or 'optional' and handbook USE-flag is set, and if this
176# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be 115# directory exists, then "doc/$KMMODULE" is added to $KMEXTRA. If there's additional
177# handled in the ebuild.
178# If the documentation is in a different subdirectory, you should add it to KMEXTRA. 116# documentation in different subdirectories, it should be added to KMEXTRA manually..
179 117
180# @ECLASS-VARIABLE: KMCOMPILEONLY 118# @ECLASS-VARIABLE: KMCOMPILEONLY
181# @DESCRIPTION: 119# @DESCRIPTION:
182# All subdirectories listed here will be extracted & compiled, but not installed. 120# All subdirectories listed here will be extracted & compiled, but not installed.
183 121
192# Specify extra parameters to pass to tar, in kde4-meta_src_extract. 130# Specify extra parameters to pass to tar, in kde4-meta_src_extract.
193# '-xpf -j' are passed to tar by default. 131# '-xpf -j' are passed to tar by default.
194 132
195# @FUNCTION: kde4-meta_pkg_setup 133# @FUNCTION: kde4-meta_pkg_setup
196# @DESCRIPTION: 134# @DESCRIPTION:
197# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in 135# Currently calls its equivalent in kde4-base.eclass(5) and checks the gcc version.
198# split ebuilds. 136# Use this one in split ebuilds.
199kde4-meta_pkg_setup() { 137kde4-meta_pkg_setup() {
200 debug-print-function ${FUNCNAME} "$@" 138 debug-print-function ${FUNCNAME} "$@"
201 139
202 kde4-base_pkg_setup 140 kde4-base_pkg_setup
203} 141}
204 142
205# @FUNCTION: kde4-meta_src_unpack 143# @FUNCTION: kde4-meta_src_unpack
206# @DESCRIPTION: 144# @DESCRIPTION:
207# This function unpacks the source for split ebuilds. See also 145# This function unpacks the source for split ebuilds.
208# kde4-meta-src_extract. 146# Further more is processed in kde4-meta_src_extract
209kde4-meta_src_unpack() { 147kde4-meta_src_unpack() {
210 debug-print-function ${FUNCNAME} "$@" 148 debug-print-function ${FUNCNAME} "$@"
211 149
212 if [[ ${BUILD_TYPE} = live ]]; then 150 if [[ ${BUILD_TYPE} = live ]]; then
151 case "${KDE_SCM}" in
152 svn)
213 migrate_store_dir 153 migrate_store_dir
214 S="${WORKDIR}/${P}" 154 S="${WORKDIR}/${P}"
215 mkdir -p "${S}" 155 mkdir -p "${S}"
216 ESVN_RESTRICT="export" subversion_src_unpack 156 ESVN_RESTRICT="export" subversion_src_unpack
217 subversion_wc_info 157 subversion_wc_info
218 subversion_bootstrap 158 subversion_bootstrap
159 ;;
160 git)
161 git-2_src_unpack
162 ;;
163 esac
164 fi
219 kde4-meta_src_extract 165 kde4-meta_src_extract
220 else
221 kde4-meta_src_extract
222 fi
223} 166}
224
225# FIXME: the difference between kde4-meta_src_extract and kde4-meta_src_unpack?
226 167
227# @FUNCTION: kde4-meta_src_extract 168# @FUNCTION: kde4-meta_src_extract
228# @DESCRIPTION: 169# @DESCRIPTION:
229# A function to unpack the source for a split KDE ebuild. 170# A function to extract the source for a split KDE ebuild.
230# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and 171# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and
231# KMTARPARAMS. 172# KMTARPARAMS.
232kde4-meta_src_extract() { 173kde4-meta_src_extract() {
233 debug-print-function ${FUNCNAME} "$@" 174 debug-print-function ${FUNCNAME} "$@"
234 175
235 if [[ ${BUILD_TYPE} = live ]]; then 176 if [[ ${BUILD_TYPE} = live ]]; then
236 local rsync_options subdir kmnamedir targetdir
237 # Export working copy to ${S} 177 # Export working copy to ${S}
238 einfo "Exporting parts of working copy to ${S}" 178 einfo "Exporting parts of working copy to ${S}"
239 kde4-meta_create_extractlists 179 kde4-meta_create_extractlists
240 180
181 case ${KDE_SCM} in
182 svn)
183 local rsync_options subdir kmnamedir targetdir wc_path escm
184
241 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/" 185 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/ --exclude=.git/"
186 wc_path="${ESVN_WC_PATH}"
187 escm="{ESVN}"
242 188
243 # Copy ${KMNAME} non-recursively (toplevel files) 189 # Copy ${KMNAME} non-recursively (toplevel files)
244 rsync ${rsync_options} "${ESVN_WC_PATH}"/${kmnamedir}* "${S}" \ 190 rsync ${rsync_options} "${wc_path}"/${kmnamedir}* "${S}" \
245 || die "${ESVN}: can't export toplevel files to '${S}'." 191 || die "${escm}: can't export toplevel files to '${S}'."
246 # Copy cmake directory 192 # Copy cmake directory
247 if [[ -d "${ESVN_WC_PATH}/${kmnamedir}cmake" ]]; then 193 if [[ -d "${wc_path}/${kmnamedir}cmake" ]]; then
248 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \ 194 rsync --recursive ${rsync_options} "${wc_path}/${kmnamedir}cmake" "${S}" \
249 || die "${ESVN}: can't export cmake files to '${S}'." 195 || die "${escm}: can't export cmake files to '${S}'."
250 fi 196 fi
251 # Copy all subdirectories 197 # Copy all subdirectories
252 for subdir in $(__list_needed_subdirectories); do 198 for subdir in $(__list_needed_subdirectories); do
253 targetdir="" 199 targetdir=""
254 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then 200 if [[ $subdir = doc/* && ! -e "$wc_path/$kmnamedir$subdir" ]]; then
255 continue 201 continue
256 fi 202 fi
257 203
258 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}" 204 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}"
259 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \ 205 rsync --recursive ${rsync_options} "${wc_path}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \
260 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'." 206 || die "${escm}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'."
261 done 207 done
262
263 if [[ ${KMNAME} = kdebase-runtime && ${PN} != kdebase-data ]]; then
264 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
265 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
266 fi
267 else
268 local abort tarball tarfile f extractlist moduleprefix postfix
269 case ${PV} in
270 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*)
271 KMTARPARAMS="${KMTARPARAMS} --lzma" # lzma
272 postfix="lzma"
273 ;;
274 *)
275 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2
276 postfix="bz2"
277 ;; 208 ;;
278 esac 209 esac
210 else
211 local abort tarball tarfile f extractlist postfix
212
213 KMTARPARAMS+=" --bzip2"
214 postfix="bz2"
215
279 case ${KMNAME} in 216 case ${KMNAME} in
280 kdebase-apps) 217 kdebase-apps)
281 # kdebase/apps -> kdebasa-apps 218 # kdebase/apps -> kdebase-apps
282 tarball="kdebase-${PV}.tar.${postfix}" 219 tarball="kdebase-${PV}.tar.${postfix}"
283 # Go one level deeper for kdebase-apps in tarballs
284 moduleprefix=apps/
285 KMTARPARAMS="${KMTARPARAMS} --transform=s|apps/||"
286 ;; 220 ;;
287 *) 221 *)
288 # Create tarball name from module name (this is the default) 222 # Create tarball name from module name (this is the default)
289 tarball="${KMNAME}-${PV}.tar.${postfix}" 223 tarball="${KMNAME}-${PV}.tar.${postfix}"
290 ;; 224 ;;
291 esac 225 esac
292 226
293 # Full patch to source tarball 227 # Full path to source tarball
294 tarfile="${DISTDIR}/${tarball}" 228 tarfile="${DISTDIR}/${tarball}"
295 229
296 # Detect real toplevel dir from tarball name - it will be used upon extraction 230 # Detect real toplevel dir from tarball name - it will be used upon extraction
297 # and in __list_needed_subdirectories 231 # and in __list_needed_subdirectories
298 topdir="${tarball%.tar.*}/" 232 topdir="${tarball%.tar.*}/"
299 233
300 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}" 234 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}"
301 235
302 kde4-meta_create_extractlists 236 kde4-meta_create_extractlists
303 237
304 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 238 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake
305 AUTHORS COPYING INSTALL README NEWS ChangeLog
306 do 239 do
307 extractlist="${extractlist} ${topdir}${moduleprefix}${f}" 240 extractlist+=" ${topdir}${f}"
308 done 241 done
309 extractlist="${extractlist} $(__list_needed_subdirectories)" 242 extractlist+=" $(__list_needed_subdirectories)"
310 243
311 pushd "${WORKDIR}" > /dev/null 244 pushd "${WORKDIR}" > /dev/null
245
246 # @ECLASS-VARIABLE: KDE4_STRICTER
247 # @DESCRIPTION:
248 # Print out all issues found executing tar / kmextract files
249 # Set on if you want to find issues in kde-base ebuild unpack sequences
312 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2 250 [[ -n ${KDE4_STRICTER} ]] && echo 'tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist}'
313 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null 251 if [[ ${I_KNOW_WHAT_I_AM_DOING} ]]; then
252 # to make the devs happy - bug 338397
253 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} || ewarn "tar extract command failed at least partially - continuing anyway"
254 else
255 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null || echo "tar extract command failed at least partially - continuing anyway"
256 fi
314 257
315 # Default $S is based on $P; rename the extracted directory to match $S if necessary 258 # Default $S is based on $P; rename the extracted directory to match $S if necessary
259 if [[ ${KMNAME} != ${PN} ]]; then
316 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\"" 260 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
261 fi
317 262
318 popd > /dev/null 263 popd > /dev/null
319 264
320 eend $? 265 eend $?
321
322 # We need to clear it here to make verification below work
323 unset moduleprefix
324 266
325 if [[ -n ${KDE4_STRICTER} ]]; then 267 if [[ -n ${KDE4_STRICTER} ]]; then
326 for f in $(__list_needed_subdirectories fatal); do 268 for f in $(__list_needed_subdirectories fatal); do
327 if [[ ! -e "${S}/${f#*/}" ]]; then 269 if [[ ! -e ${S}/${f#*/} ]]; then
328 eerror "'${f#*/}' is missing" 270 eerror "'${f#*/}' is missing"
329 abort=true 271 abort=true
330 fi 272 fi
331 done 273 done
332 [[ -n ${abort} ]] && die "There were missing files." 274 [[ -n ${abort} ]] && die "There were missing files."
343# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, 285# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
344# KMEXTRACTONLY and KMTARPARAMS. 286# KMEXTRACTONLY and KMTARPARAMS.
345kde4-meta_create_extractlists() { 287kde4-meta_create_extractlists() {
346 debug-print-function ${FUNCNAME} "$@" 288 debug-print-function ${FUNCNAME} "$@"
347 289
348 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then 290 # Add default handbook locations
291 # FIXME - legacy code - remove when 4.4.5 is gone or preferrably port 4.4.5.
292 if [[ $(get_kde_version) < 4.5 ]] && has handbook ${IUSE//+} && use handbook && [[ -z ${KMNOMODULE} ]]; then
349 # We use the basename of $KMMODULE because $KMMODULE can contain 293 # We use the basename of $KMMODULE because $KMMODULE can contain
350 # the path to the module subdirectory. 294 # the path to the module subdirectory.
295 KMEXTRA_NONFATAL+="
296 doc/${KMMODULE##*/}"
297 fi
298
299 # Add default handbook locations
300 if [[ -z ${KMNOMODULE} ]] && ( [[ ${KDE_HANDBOOK} == always ]] || ( [[ ${KDE_HANDBOOK} == optional ]] && use handbook ) ); then
351 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}" 301 KMEXTRA_NONFATAL+=" doc/${KMMODULE##*/}"
352 fi 302 fi
353 303
354 # Add some CMake-files to KMEXTRACTONLY. 304 # Add some CMake-files to KMEXTRACTONLY.
355 # Note that this actually doesn't include KMEXTRA handling. 305 # Note that this actually doesn't include KMEXTRA handling.
356 # In those cases you should care to add the relevant files to KMEXTRACTONLY 306 # In those cases you should care to add the relevant files to KMEXTRACTONLY
357 case ${KMNAME} in 307 case ${KMNAME} in
358 kdebase) 308 kdebase | kdebase-apps | kde-base-apps)
359 KMEXTRACTONLY="${KMEXTRACTONLY} 309 KMEXTRACTONLY+="
360 apps/config-apps.h.cmake
361 apps/ConfigureChecks.cmake"
362 ;;
363 kdebase-apps)
364 KMEXTRACTONLY="${KMEXTRACTONLY}
365 config-apps.h.cmake 310 config-apps.h.cmake
366 ConfigureChecks.cmake" 311 ConfigureChecks.cmake"
367 ;; 312 ;;
368 kdebase-runtime) 313 kdebase-runtime | kde-runtime)
369 KMEXTRACTONLY="${KMEXTRACTONLY} 314 KMEXTRACTONLY+="
370 config-runtime.h.cmake" 315 config-runtime.h.cmake"
371 ;; 316 ;;
372 kdebase-workspace) 317 kdebase-workspace | kde-workspace)
373 KMEXTRACTONLY="${KMEXTRACTONLY} 318 KMEXTRACTONLY+="
374 config-unix.h.cmake 319 config-unix.h.cmake
375 ConfigureChecks.cmake 320 ConfigureChecks.cmake
376 config-workspace.h.cmake 321 config-workspace.h.cmake
377 config-X11.h.cmake 322 config-X11.h.cmake
378 startkde.cmake 323 startkde.cmake
379 KDE4WorkspaceConfig.cmake.in" 324 KDE4WorkspaceConfig.cmake.in"
380 ;; 325 ;;
381 kdegames) 326 kdegames)
382 if [[ ${PN} != libkdegames ]]; then 327 if [[ ${PN} != libkdegames ]]; then
383 KMEXTRACTONLY="${KMEXTRACTONLY} 328 KMEXTRACTONLY+="
384 libkdegames" 329 libkdegames/"
330 KMLOADLIBS="${KMLOADLIBS} libkdegames"
385 fi 331 fi
386 ;; 332 ;;
387 kdepim) 333 kdepim)
388 if [[ ${PN} != libkdepim ]]; then 334 if [[ ${PN} != libkdepim ]]; then
389 KMEXTRACTONLY="${KMEXTRACTONLY} 335 KMEXTRACTONLY+="
390 libkdepim" 336 libkdepim/"
391 fi 337 fi
392 case ${SLOT} in 338 KMEXTRACTONLY+="
393 4.3|live)
394 KMEXTRACTONLY="${KMEXTRACTONLY}
395 kdepim-version.h
396 config-enterprise.h.cmake" 339 config-enterprise.h.cmake
340 kleopatra/ConfigureChecks.cmake"
341 if ! [[ $(get_kde_version) < 4.5 ]]; then
342 KMEXTRACTONLY+="
343 CTestCustom.cmake
344 kdepim-version.h.cmake"
345 else
346 KMEXTRACTONLY+="
347 kdepim-version.h"
348 fi
349 if has kontact ${IUSE//+} && use kontact; then
350 KMEXTRA+="
351 kontact/plugins/${PLUGINNAME:-${PN}}/"
352 fi
353 ;;
354 kdeutils)
355 KMEXTRACTONLY+="
356 kdeutils-version.h"
357 ;;
358 koffice)
359 KMEXTRACTONLY+="
360 filters/config-filters.h.cmake
361 "
362 case ${PV} in
363 2.[12].*)
364 KMEXTRACTONLY+="
365 config-endian.h.cmake
366 config-openexr.h.cmake
367 config-opengl.h.cmake
368 config-prefix.h.cmake"
397 ;; 369 ;;
398 esac 370 esac
399 KMEXTRACTONLY="${KMEXTRACTONLY}
400 kleopatra/ConfigureChecks.cmake"
401 if has kontact ${IUSE//+} && use kontact; then
402 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}"
403 KMEXTRACTONLY="${KMEXTRACTONLY} kontactinterfaces/"
404 fi
405 ;;
406 koffice)
407 KMEXTRACTONLY="${KMEXTRACTONLY}
408 config-endian.h.cmake
409 filters/config-filters.h.cmake
410 config-openctl.h.cmake
411 config-openexr.h.cmake
412 config-opengl.h.cmake
413 config-prefix.h.cmake"
414 ;; 371 ;;
415 esac 372 esac
416 # Don't install cmake modules for split ebuilds, to avoid collisions. 373 # Don't install cmake modules for split ebuilds, to avoid collisions.
374 # note: kdegraphics >= 4.6.2 does not even have code to do that, so we
375 # should not try in that case
376 # note2: kdeedu 4.6.4 does not have a cmake/modules/ subdir anymore :(
377 # it may be possible to formulate this shorter, but it should also
378 # still be understandable...
379 if [[ ${KMNAME} != kdegraphics || ( ( $(get_kde_version) != 4.6 || ${PV} < 4.6.2 ) && $(get_kde_version) < 4.7 ) ]] \
380 && ! [[ ${KMNAME} == kdeedu && ${PV} == 4.6.4 ]]; then
417 case ${KMNAME} in 381 case ${KMNAME} in
418 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics|kdepim) 382 kdebase-runtime|kde-runtime|kdebase-workspace|kde-workspace|kdeedu|kdegames|kdegraphics)
419 case ${PN} in 383 case ${PN} in
420 libkdegames|libkdeedu|marble|libkworkspace) 384 libkdegames|libkdeedu|libkworkspace)
421 KMEXTRA="${KMEXTRA} 385 KMEXTRA+="
422 cmake/modules/" 386 cmake/modules/"
423 ;; 387 ;;
424 *) 388 *)
425 KMCOMPILEONLY="${KMCOMPILEONLY} 389 KMCOMPILEONLY+="
426 cmake/modules/" 390 cmake/modules/"
427 ;; 391 ;;
428 esac 392 esac
429 ;; 393 ;;
430 esac 394 esac
395 fi
431 396
432 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}" 397 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}"
433} 398}
434 399
435__list_needed_subdirectories() { 400__list_needed_subdirectories() {
436 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist 401 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
437 402
438 # We expand KMEXTRA by adding CMakeLists.txt files 403 # We expand KMEXTRA by adding CMakeLists.txt files
439 kmextra="${KMEXTRA}" 404 kmextra="${KMEXTRA}"
440 [[ ${1} != fatal ]] && kmextra="${kmextra} ${KMEXTRA_NONFATAL}" 405 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
441 for i in ${kmextra}; do 406 for i in ${kmextra}; do
442 kmextra_expanded="${kmextra_expanded} ${i}" 407 kmextra_expanded+=" ${i}"
443 j=$(dirname ${i}) 408 j=$(dirname ${i})
444 while [[ ${j} != "." ]]; do 409 while [[ ${j} != "." ]]; do
445 kmextra_expanded="${kmextra_expanded} ${j}/CMakeLists.txt"; 410 kmextra_expanded+=" ${j}/CMakeLists.txt";
446 j=$(dirname ${j}) 411 j=$(dirname ${j})
447 done 412 done
448 done 413 done
449 414
450 # Expand KMMODULE 415 # Expand KMMODULE
451 if [[ -n ${KMMODULE} ]]; then 416 if [[ -n ${KMMODULE} ]]; then
452 kmmodule_expanded="${KMMODULE}" 417 kmmodule_expanded="${KMMODULE}"
453 j=$(dirname ${KMMODULE}) 418 j=$(dirname ${KMMODULE})
454 while [[ ${j} != "." ]]; do 419 while [[ ${j} != "." ]]; do
455 kmmodule_expanded="${kmmodule_expanded} ${j}/CMakeLists.txt"; 420 kmmodule_expanded+=" ${j}/CMakeLists.txt";
456 j=$(dirname ${j}) 421 j=$(dirname ${j})
457 done 422 done
458 fi 423 fi
459 424
460 # Expand KMCOMPILEONLY 425 # Expand KMCOMPILEONLY
461 for i in ${KMCOMPILEONLY}; do 426 for i in ${KMCOMPILEONLY}; do
462 kmcompileonly_expanded="${kmcompileonly_expanded} ${i}" 427 kmcompileonly_expanded+=" ${i}"
463 j=$(dirname ${i}) 428 j=$(dirname ${i})
464 while [[ ${j} != "." ]]; do 429 while [[ ${j} != "." ]]; do
465 kmcompileonly_expanded="${kmcompileonly_expanded} ${j}/CMakeLists.txt"; 430 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
466 j=$(dirname ${j}) 431 j=$(dirname ${j})
467 done 432 done
468 done 433 done
469 434
470 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 435 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
474 # Create final list of stuff to extract 439 # Create final list of stuff to extract
475 # We append topdir only when specified (usually for tarballs) 440 # We append topdir only when specified (usually for tarballs)
476 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 441 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
477 ${KMEXTRACTONLY} 442 ${KMEXTRACTONLY}
478 do 443 do
479 extractlist="${extractlist} ${topdir}${moduleprefix}${i}" 444 extractlist+=" ${topdir}${i}"
480 done 445 done
481 446
482 echo ${extractlist} 447 echo ${extractlist}
483} 448}
484 449
490 455
491 kde4-meta_change_cmakelists 456 kde4-meta_change_cmakelists
492 kde4-base_src_prepare 457 kde4-base_src_prepare
493} 458}
494 459
495# FIXME: no comment here? 460# @FUNCTION: _change_cmakelists_parent_dirs
461# @DESCRIPTION:
462# Adjust CMakeLists.txt to shadow subdirectories
463# that are not required for the build.
496_change_cmakelists_parent_dirs() { 464_change_cmakelists_parent_dirs() {
497 debug-print-function ${FUNCNAME} "$@" 465 debug-print-function ${FUNCNAME} "$@"
498 466
499 local _olddir _dir 467 local _olddir _dir
500 _dir="${S}"/${1} 468 _dir="${S}"/${1}
501 until [[ ${_dir} == "${S}" ]]; do 469 until [[ ${_dir} == ${S} ]]; do
502 _olddir=$(basename "${_dir}") 470 _olddir=$(basename "${_dir}")
503 _dir=$(dirname "${_dir}") 471 _dir=$(dirname "${_dir}")
504 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}" 472 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}"
505 if [[ -f ${_dir}/CMakeLists.txt ]]; then 473 if [[ -f ${_dir}/CMakeLists.txt ]]; then
506 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \ 474 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
508 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}" 476 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
509 fi 477 fi
510 done 478 done
511} 479}
512 480
513# FIXME: add description
514# @FUNCTION: kde4-meta_change_cmakelists 481# @FUNCTION: kde4-meta_change_cmakelists
515# @DESCRIPTION: 482# @DESCRIPTION:
483# Adjust CMakeLists.txt to comply to our splitting.
516kde4-meta_change_cmakelists() { 484kde4-meta_change_cmakelists() {
517 debug-print-function ${FUNCNAME} "$@" 485 debug-print-function ${FUNCNAME} "$@"
518 486
519 pushd "${S}" > /dev/null 487 pushd "${S}" > /dev/null
520 488
521 comment_all_add_subdirectory ./ 489 comment_all_add_subdirectory ./
522 490
523 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 491 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
524 if [[ -f "${S}"/CMakeLists.txt ]]; then 492 if [[ -f CMakeLists.txt ]]; then
525 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 493 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
526 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 494 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
527 -i "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 495 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
528 fi 496 fi
529 497
530 if [[ -z ${KMNOMODULE} ]]; then 498 if [[ -z ${KMNOMODULE} ]]; then
531 # Restore "add_subdirectory" in $KMMODULE subdirectories 499 # Restore "add_subdirectory" in $KMMODULE subdirectories
532 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 500 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
501 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
533 die "${LINENO}: died in KMMODULE section" 502 die "${LINENO}: died in KMMODULE section"
534 _change_cmakelists_parent_dirs ${KMMODULE} 503 _change_cmakelists_parent_dirs ${KMMODULE}
535 fi 504 fi
536 505
537 local i 506 local i
538 507
539 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY 508 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
540 for i in ${KMEXTRACTONLY}; do 509 for i in ${KMEXTRACTONLY}; do
541 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then 510 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
542 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \ 511 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
512 -i ${i}/../CMakeLists.txt || \
543 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}" 513 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
544 fi 514 fi
545 done 515 done
546 516
547 # KMCOMPILEONLY 517 # KMCOMPILEONLY
569 # KMEXTRA_NONFATAL section 539 # KMEXTRA_NONFATAL section
570 for i in ${KMEXTRA_NONFATAL}; do 540 for i in ${KMEXTRA_NONFATAL}; do
571 if [[ -d "${S}"/${i} ]]; then 541 if [[ -d "${S}"/${i} ]]; then
572 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 542 find "${S}"/${i} -name CMakeLists.txt -print0 | \
573 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 543 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
574 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 544 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
575 _change_cmakelists_parent_dirs ${i} 545 _change_cmakelists_parent_dirs ${i}
576 fi 546 fi
577 done 547 done
578 548
579 case ${KMNAME} in 549 case ${KMNAME} in
580 kdebase-workspace) 550 kdebase-workspace | kde-workspace)
581 # COLLISION PROTECT section 551 # COLLISION PROTECT section
582 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 552 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
583 # not as a part of every package. 553 # not as a part of every package.
584 if [[ ${PN} != kdebase-startkde && -f "${S}"/CMakeLists.txt ]]; then 554 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
585 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 555 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
586 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 556 sed -e '/startkde/s/^/#DONOTINSTALL /' \
587 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 557 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
588 fi 558 fi
589 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 559 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
590 if [[ ${PN} != libkworkspace ]]; then 560 if [[ ${PN} != libkworkspace ]]; then
591 sed -i -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 561 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
592 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip EXPORT section" 562 -i CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section"
593 fi 563 fi
594 ;; 564 ;;
595 kdebase-runtime) 565 kdebase-runtime | kde-runtime)
596 # COLLISION PROTECT section 566 # COLLISION PROTECT section
597 # Only install the kde4 script as part of kde-base/kdebase-data 567 # Only install the kde4 script as part of kde-base/kdebase-data
598 if [[ ${PN} != kdebase-data && -f "${S}"/CMakeLists.txt ]]; then 568 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
599 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 569 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
600 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 570 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
601 fi 571 fi
572 ;;
573 kdenetwork)
574 # Disable hardcoded kdepimlibs check
575 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
576 -i CMakeLists.txt || die "failed to disable hardcoded checks"
602 ;; 577 ;;
603 kdepim) 578 kdepim)
579 # Disable hardcoded checks
580 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
581 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
582 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
583 -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
584 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
585 -i CMakeLists.txt || die "failed to disable hardcoded checks"
586 # Disable broken or redundant build logic
587 if ( has kontact ${IUSE//+} && use kontact ) || [[ ${PN} = kontact ]]; then
588 sed -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
589 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
590 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
591 fi
592 if [[ $(get_kde_version) < 4.5 ]]; then
604 case ${PN} in 593 case ${PN} in
605 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn) 594 kalarm|kmailcvt|kontact|korganizer|korn)
606 sed -i -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \ 595 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
607 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed" 596 -e '/add_custom_target(kmail_xml /,/)/p' \
597 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
608 _change_cmakelists_parent_dirs kmail 598 _change_cmakelists_parent_dirs kmail
609 ;; 599 ;;
610 esac 600 esac
601 fi
602 ;;
603 kdewebdev)
604 # Disable hardcoded checks
605 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
606 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
607 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
608 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
609 -i CMakeLists.txt || die "failed to disable hardcoded checks"
611 ;; 610 ;;
612 koffice) 611 koffice)
613 # prevent collisions 612 # Prevent collisions
614 if [[ ${PN} != koffice-data ]]; then 613 if [[ ${PN} != koffice-data ]]; then
615 sed -i -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \ 614 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
616 "${S}"/cmake/modules/CMakeLists.txt || \ 615 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
616 sed -e '/install(.\+config-openexr\.h.\+)/d' \
617 die "${LINENO}: sed died in collision prevention section" 617 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
618 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
619 "${S}"/CMakeLists.txt || \
620 die "${LINENO}: sed died in collision prevention section"
621 fi 618 fi
622 esac 619 esac
623 620
624 popd > /dev/null 621 popd > /dev/null
625} 622}
629# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split 626# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
630# ebuilds. 627# ebuilds.
631kde4-meta_src_configure() { 628kde4-meta_src_configure() {
632 debug-print-function ${FUNCNAME} "$@" 629 debug-print-function ${FUNCNAME} "$@"
633 630
631 # backwards-compatibility: make mycmakeargs an array, if it isn't already
632 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
633 mycmakeargs=(${mycmakeargs})
634 fi
635
636 # Set some cmake default values here (usually workarounds for automagic deps)
637 case ${KMNAME} in
638 kdewebdev)
639 mycmakeargs=(
640 -DWITH_KdepimLibs=OFF
641 -DWITH_LibXml2=OFF
642 -DWITH_LibXslt=OFF
643 -DWITH_Boost=OFF
644 -DWITH_LibTidy=OFF
645 "${mycmakeargs[@]}"
646 )
647 ;;
648 esac
649
634 kde4-base_src_configure 650 kde4-base_src_configure
635} 651}
636 652
637# @FUNCTION: kde4-meta_src_compile 653# @FUNCTION: kde4-meta_src_compile
638# @DESCRIPTION: 654# @DESCRIPTION:
639# General function for compiling split KDE4 applications. 655# General function for compiling split KDE4 applications.
640# Overrides kde4-base_src_compile. 656# Overrides kde4-base_src_compile.
641kde4-meta_src_compile() { 657kde4-meta_src_compile() {
642 debug-print-function ${FUNCNAME} "$@" 658 debug-print-function ${FUNCNAME} "$@"
643 659
644 kde4-base_src_compile 660 kde4-base_src_compile "$@"
645} 661}
646 662
647# @FUNCTION: kde4-meta_src_test 663# @FUNCTION: kde4-meta_src_test
648# @DESCRIPTION: 664# @DESCRIPTION:
649# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 665# Currently just calls its equivalent in kde4-base.eclass(5) if
650# ebuilds. 666# I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
651kde4-meta_src_test() { 667kde4-meta_src_test() {
652 debug-print-function $FUNCNAME "$@" 668 debug-print-function $FUNCNAME "$@"
653 669
670 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
654 kde4-base_src_test 671 kde4-base_src_test
672 else
673 einfo "Tests disabled"
674 fi
655} 675}
656 676
657# @FUNCTION: kde4-meta_src_install 677# @FUNCTION: kde4-meta_src_install
658# @DESCRIPTION: 678# @DESCRIPTION:
659# Function for installing KDE4 split applications. 679# Function for installing KDE4 split applications.
660kde4-meta_src_install() { 680kde4-meta_src_install() {
661 debug-print-function $FUNCNAME "$@" 681 debug-print-function $FUNCNAME "$@"
662 682
663 kde4-meta_src_make_doc 683 # Search ${S}/${KMMODULE} and install common documentation files found
664 cmake-utils_src_install
665
666 if [[ -n ${KMSAVELIBS} ]]; then
667 install_library_dependencies
668 fi
669}
670
671# @FUNCTION: kde4-meta_src_make_doc
672# @DESCRIPTION:
673# This function searches in ${S}/${KMMODULE},
674# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist.
675kde4-meta_src_make_doc() {
676 debug-print-function ${FUNCNAME} "$@"
677
678 local doc 684 local doc
679 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 685 for doc in "${S}/${KMMODULE}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
680 [[ -s ${KMMODULE}/${doc} ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}" 686 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}"
681 done 687 done
682 688
683 kde4-base_src_make_doc 689 kde4-base_src_install
690}
691
692# @FUNCTION: kde4-meta_pkg_preinst
693# @DESCRIPTION:
694# Invoke its equivalent in kde4-base.eclass.
695kde4-meta_pkg_preinst() {
696 debug-print-function ${FUNCNAME} "$@"
697
698 kde4-base_pkg_preinst
684} 699}
685 700
686# @FUNCTION: kde4-meta_pkg_postinst 701# @FUNCTION: kde4-meta_pkg_postinst
687# @DESCRIPTION: 702# @DESCRIPTION:
688# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 703# Invoke kbuildsycoca4.
689# ebuilds.
690kde4-meta_pkg_postinst() { 704kde4-meta_pkg_postinst() {
691 debug-print-function ${FUNCNAME} "$@" 705 debug-print-function ${FUNCNAME} "$@"
692 706
693 kde4-base_pkg_postinst 707 kde4-base_pkg_postinst
694} 708}

Legend:
Removed from v.1.16  
changed lines
  Added in v.1.54

  ViewVC Help
Powered by ViewVC 1.1.20